import 'package:article_flutter_riverpod/presentation/07_overrides_example.dart';
import 'package:flutter/material.dart';
import 'package:flutter_riverpod/flutter_riverpod.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:mockito/annotations.dart';
import 'package:mockito/mockito.dart';

import '07_overrides_test.mocks.dart';

@GenerateMocks([TodosRepository])
void main() {
  group('TodoExample', () {
    testWidgets('doit vérifier', (tester) async {
      // given:
      const mocksTodos = [
        Todo(id: 0, title: 'Test'),
      ];

      // and:
      final mockTodosRepository = MockTodosRepository();
      when(mockTodosRepository.getTodos()).thenReturn(mocksTodos);

      // when:
      await tester.pumpWidget(
        ProviderScope(
          overrides: [
            todosRepositoryProvider.overrideWithValue(mockTodosRepository),
          ],
          child: const MaterialApp(
            home: Material(
              child: TodoList(),
            ),
          ),
        ),
      );

      // then:
      expect(find.byType(TodoListItem), findsOneWidget);
    });
  });
}
